using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UIManager : MonoBehaviour
{
    #region Variables
    [Header("User settings")]
    public Slider loadingBar;

    /// <summary>
    /// What weight do we give to the generator vs the applier?
    /// </summary>
    public float generatorLoadingWeight = 0.8f;

    [Header("Autogenerated values")]
    public static UIManager singleton;

	private int terrainPieces;

    private int generatorIncr, applierIncr;

    #endregion Variables

    private void Start()
    {
        this.InstantiateSingleton(ref singleton);
    }

    #region Loading Bar
    public void SetUpLoadingBar(int terrainPieces)
    {
        this.terrainPieces = terrainPieces;
        loadingBar.maxValue = terrainPieces;
        loadingBar.minValue = 0;
    }

    public void UpdateLoadingBar_GeneratorDone()
    {
        generatorIncr++;
        UpdateLoading();
    }

    public void UpdateLoadingBar_ApplierDone()
    {
        applierIncr++;
        UpdateLoading();
    }

    private void UpdateLoading()
    {
        loadingBar.value = generatorLoadingWeight * generatorIncr + 
            (1 - generatorLoadingWeight) * applierIncr;
    }
    #endregion
}
