﻿using System.Collections;
using System;
using UnityEngine;
using System.Collections.Generic;

[Serializable]
public struct BiomeParameter
{
    public string name;
    [Tooltip("What is used to generate the biome.")]
    public List<Octave> map;
    [Tooltip("What is used to generate the terrain.")]
    public List<Octave> shapeMap;
    [Tooltip("What is used to map terrain materials to heights.")]
    public List<TerrainHeightMap> heightMap;
    public Color debugColor;
}

[Serializable]
public struct TerrainHeightMap
{
    public float minHeight;
    public float maxHeight;

    public Texture texture;
}